<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline>
      <el-form-item>
        <el-input
          v-model="searchForm.label"
          placeholder="请输入名称"
          clearable
          style="width: 180px"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="tableList">
      <el-table-column prop="label" label="名称" />
      <el-table-column prop="value" label="编码" />
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="remark" label="备注" />
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="更新人" prop="updator	" width="150px" />
      <el-table-column label="操作">
        <template #default="{ row }">
          <el-button type="primary" text @click="openForm('update', row.id)"> 修改 </el-button>
          <el-button type="danger" text @click="handleDelete(row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="handleQuery"
    />

    <DialogCartype ref="cartypeDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="CartypeSetting">
import { dateFormatter } from '@/utils/formatTime'
import * as dictApi from '@/api/system/dict/dict.data'
import DialogCartype from './DialogCartype.vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const searchForm = ref({
  dictType: 'license_type',
  label: '',
  pageNo: 1,
  pageSize: 20
})

const total = ref(0)
const cartypeDialog = ref()
const tableList = ref([])
const loading = ref(false)

function handleQuery() {
  searchForm.value.pageNo = 1
  getList()
}
function resetQuery() {
  searchForm.value = {
    dictType: 'license_type',
    label: '',
    pageSize: 20,
    pageNo: 1
  }
  getList()
}
async function getList() {
  loading.value = true
  try {
    const data = await dictApi.getDictDataPage(searchForm.value)
    tableList.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

function openForm(type, id = null) {
  cartypeDialog.value.open(type, id)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await dictApi.deleteDictData(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
onMounted(() => {
  getList()
})
</script>

<style lang="scss" scoped></style>
